<?php
/**
*
*===================================================================
*
*  Crunch -- ACP Module File
*-------------------------------------------------------------------
*	Script info:
* Version:		1.0.0 - "Moonshine" - RC 2
* Copyright:	(c) 2009 - Obsidian
* License:		http://opensource.org/licenses/gpl-license.php  |  GNU Public License v2
* Package:		ACP
*
*===================================================================
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
 * @package acp
 */
class acp_crunch
{
	var $u_action;

	function main($id, $mode)
	{
		global $config, $db, $user, $auth, $template, $cache;
		global $phpbb_root_path, $phpbb_admin_path, $phpEx, $table_prefix;
		
		include("{$phpbb_root_path}includes/functions_user.$phpEx");
		include("{$phpbb_root_path}includes/crunch.$phpEx");
		crunch::init();

	//! Quick var-checking and var setup.
		$submit = (isset($_POST['submit'])) ? true : false;
		$preview = (isset($_POST['preview'])) ? true : false;
		$checkversion = (isset($_POST['checkversion'])) ? true : false;
		$action	= request_var('action', '');
		$crunch_id	= request_var('crunch_id', 0);
		$errors = array();
		
	//! Setup some things for the module.
		$user->add_lang('mods/info_acp_crunch');
		$this->tpl_name = 'acp_crunch';
		$form_key = 'acp_crunch';
		add_form_key($form_key);
		
	//! Hath we an invalid form key?
		if (($submit || $preview) && !check_form_key($form_key))
		{
			$errors[] = $user->lang['FORM_INVALID'];
		}

	//! Common template variables for this module
		$template->assign_var('U_ACTION', $this->u_action);
		
	//! Install check stuffs...
		// So, is it actually installed?
		if(!isset($config['crunch_version']))
		{
	 		trigger_error($user->lang['CRUNCH_NOT_INSTALLED'], E_USER_WARNING);
		}
		
		// Are we running a current copy of the database install versus the fileset?
		if(version_compare($config['crunch_version'], CRUNCH_VERSION, '<'))
		{
			trigger_error($user->lang['CRUNCH_DB_NOT_CURRENT'], E_USER_WARNING);
		}
		
		// Check to see if the install directory for Crunch is present.  If we're in DEBUG_EXTRA though, we won't care.
		if(@file_exists("{$phpbb_root_path}/install_crunch") && !defined('DEBUG_EXTRA'))
		{
			// IDIOT...Get rid of the directory already, would you?  >_<
			trigger_error($user->lang['CRUNCH_INSTALL_DIR_PRESENT'], E_USER_WARNING);
		}
		
	//! Mode switch.  Here is where we split off for each mode and react to certain circumstances.
		switch ($mode)
		{
			//~ Begin module mode ACP_CRUNCH_SETTINGS
			case 'settings':
				// Boolean settings variables.  
				$bool_settings = array(
					'crunch_enabled' 					=> 'CRUNCH_ENABLED',
				);
				// Non-bool settings variables.
				/*
				$main_settings = array(
				);
				*/
				
				// Okay, here's where we start processing the module's information, but only if we have a submit and a valid form key, plus no errors.
				if($submit && check_form_key($form_key) && !sizeof($errors))
				{
					// Process boolean vars first...
					$config_vars = array_keys($bool_settings);
					foreach ($config_vars as $config_var)
					{
						if(request_var($config_var, 0) != 0)
						{
							set_config($config_var, 1);
						}
						else
						{
							set_config($config_var, 0);
						}
					}
					// Non-boolean vars now.
					/*
					$config_vars = array_keys($main_settings);
					foreach ($config_vars as $config_var)
					{
						set_config($config_var, request_var($config_var, ''));
					}
					*/
					
					trigger_error($user->lang['CONFIG_UPDATED'] . adm_back_link($this->u_action));
				}
				else  //Okay, so we want to output previous data...let's do that then.  Also we'll display encountered errors here.
				{
					//Output previous settings...
					foreach ($bool_settings as $setting => $template_var)
					{
						$template->assign_var($template_var, (($config[$setting] == 1) ? true : false));
					}
					// Non boolean vars here.
					/*
					foreach ($main_settings as $setting => $template_var)
					{
						$template->assign_var($template_var, $config[$setting]);
					}
					*/
					
					if($checkversion)
					{
						crunch::version($up_to_date, $latest_version, $announcement_url);
						$update_link = append_sid($phpbb_root_path . 'install_crunch/index.' . $phpEx, 'mode=update');
						$template->assign_vars(array(
							'UPDATE_INSTRUCTIONS'			=> sprintf($user->lang['CRUNCH_GET_UPDATE'], $announcement_url, $update_link),
							'CRUNCH_UP_TO_DATE'				=> $up_to_date,
							'LATEST_VERSION'				=> $latest_version,
							'CURRENT_VERSION'				=> $config['crunch_version'],
							'S_MODE_CRUNCH_VERSION_CHECK'	=> true,
						));
						
						
					}
					
					$template->assign_vars(array(
						'CRUNCH_BIG_VERSION'			=> CRUNCH_BIG_VERSION,
						'CRUNCH_VERSION'				=> CRUNCH_VERSION,
						'S_ERROR'						=> (sizeof($errors)) ? true : false,
						'ERROR_MSG'						=> implode('<br />', $errors),
						'S_MODE_CRUNCH_SETTINGS'		=> true,
					));
					
					$l_title = $user->lang['ACP_CRUNCH_SETTINGS_TITLE'];
					$l_title_explain = $user->lang['ACP_CRUNCH_SETTINGS_EXPLAIN'];
				}
			break; //~ End module mode ACP_CRUNCH_SETTINGS
		
			//~ Begin module mode ACP_CRUNCH_MANAGE
			case 'manage':
				switch ($action)
				{
					case 'add':
					case 'edit':
						// Okay, we're going to do something productive, and not stare at a dropdown list of Crunch entries.
						$crunch_data = array();
						$template->assign_var('S_MODE_CRUNCH_MANAGE', true);
						switch($action)
						{
						//! Edit action for Crunch management...
							case 'edit':
							$crunch_data += array(
								'crunch_id'					=> $crunch_id,
							);
							
							case 'add':
							
							$crunch_data += array(
								'crunch_text'				=> utf8_normalize_nfc(request_var('crunch_text', '', true)),
								'crunch_subject'			=> utf8_normalize_nfc(request_var('crunch_subject', '', true)),
								'crunch_uid'				=> '',
								'crunch_options'			=> 7,
								'crunch_bitfield'			=> '',
								'crunch_parse_bbcode'		=> request_var('crunch_parse_bbcode', true),
								'crunch_parse_urls'			=> request_var('crunch_parse_urls', true),
								'crunch_parse_smilies'		=> request_var('crunch_parse_smilies', true),
								'poster_id'					=> (int) request_var('poster_id', 0),
								'poster_username'			=> utf8_normalize_nfc(request_var('username', '', true)),
							);
							break;
						}
						
						if($crunch_data['poster_id'] == ANONYMOUS && $submit)
						{
							$errors[] = $user->lang['NO_USER'];
						}
						
						// Obviously, we won't have a Crunch ID if we're adding a Crunch, right?
						if($action == 'add')
						{
							$crunch_id = false;
						}
						elseif($action == 'edit' && $submit)
						{
							// Make sure the Crunch actually exists, mmkay?
							if(!crunch::exists($crunch_id))
							{
								$errors[] = $user->lang['INVALID_CRUNCH'];
							}
						}
						
					//! Grabbeth the poster ID if we don't already have it.
						if (!empty($crunch_data['poster_username']) && $submit)
						{
							$sql = 'SELECT user_id
								FROM ' . USERS_TABLE . "
								WHERE username_clean = '" . $db->sql_escape(utf8_clean_string($crunch_data['poster_username'])) . "'";
							$result = $db->sql_query($sql);
							$crunch_data['poster_id'] = (int) $db->sql_fetchfield('user_id');
							$db->sql_freeresult($result);

							if (!$crunch_data['poster_id'])
							{
								$errors[] = $user->lang['NO_USER'];
							}
						}
						
					//! Make sure we've got a valid user here.  It's another query, but meh. It's worth it.
						if(!empty($crunch_data['poster_id']) && $submit)
						{
							$sql = 'SELECT COUNT(user_id) AS users 
								FROM ' . USERS_TABLE . '
									WHERE user_id = ' . (int) $db->sql_escape($crunch_data['poster_id']);
							$result = $db->sql_query($sql);
							$user_count = (int) $db->sql_fetchfield('users');
							$db->sql_freeresult($result);
							if (!$user_count)
							{
								$errors[] = $user->lang['NO_USER'];
							}
						}
						
					//! Submit the Crunch!
						if($submit && check_form_key($form_key) && !sizeof($errors))
						{
							$result = crunch::make($crunch_id, $crunch_data['poster_id'], $crunch_data['crunch_text'], $crunch_data['crunch_subject'], $crunch_data['crunch_options'], $crunch_data['crunch_parse_bbcode'], $crunch_data['crunch_parse_urls'], $crunch_data['crunch_parse_smilies']);
							if($action == 'add')
							{
								if($result === crunch::POST_FAILED)
								{
									trigger_error($user->lang['CRUNCH_POST_FAILED'] . adm_back_link($this->u_action), E_USER_WARNING);
								}
								else
								{
									trigger_error($user->lang['CRUNCH_POST_SUCCESS'] . adm_back_link($this->u_action));
								}
							}
							elseif($action == 'edit')
							{
								if($result === crunch::EDIT_FAILED)
								{
									trigger_error($user->lang['CRUNCH_EDIT_FAILED'] . adm_back_link($this->u_action), E_USER_WARNING);
								}
								else
								{
									trigger_error($user->lang['CRUNCH_EDIT_SUCCESS'] . adm_back_link($this->u_action));
								}
							}
						}
						
					//! Non-submit or submit failure code for editing and adding.
						
						// Are we editing?  Pull previous data if we didn't fail the submit.
						if($action == 'edit' && !$submit && !$preview)
						{
							// We're just going to override the old values with previous values from the Crunch.
							$edit_data = crunch::edit($crunch_id);
							foreach($edit_data as $key => $value)
							{
								$crunch_data[$key] = $value;
							}
							
							
							// Grabbeth username associated with user ID...
							$sql = 'SELECT username
								FROM ' . USERS_TABLE . "
								WHERE user_id = '" . (int) $db->sql_escape($crunch_data['poster_id']) . "'";
							$result = $db->sql_query($sql);
							$crunch_data['poster_username'] = $db->sql_fetchfield('username');
							$db->sql_freeresult($result);
							
							// Even if the user by that user ID doesn't exist anymore, we're okay.  
							// It should force the user to choose someone else on submit.
							// Just cross your fingers, though.
						}
						
						if($action == 'edit')
						{
							$s_hidden_fields = build_hidden_fields(array(
								'crunch_id'    => $crunch_data['crunch_id'],
							));
						}
						
						if($preview)
						{
							$this->message_preview($crunch_data['crunch_text'], $crunch_data['crunch_parse_bbcode'], $crunch_data['crunch_parse_urls'], $crunch_data['crunch_parse_smilies']);
						}
						
						//! Okay, I guess it's time to display stuffs.
						$template->assign_vars(array(
							'S_HIDDEN_FIELDS'			=> (isset($s_hidden_fields)) ? $s_hidden_fields : false,
							'S_BBCODE_CHECKED'			=> ($crunch_data['crunch_parse_bbcode']) ? true : false,
							'S_SMILIES_CHECKED'			=> ($crunch_data['crunch_parse_smilies']) ? true : false,
							'S_URLS_CHECKED'			=> ($crunch_data['crunch_parse_urls']) ? true : false,
							'POSTER_USERNAME'			=> $crunch_data['poster_username'],
							'POSTER_ID'					=> ($crunch_data['poster_id'] != 0) ? $crunch_data['poster_id'] : false,
							'CRUNCH_SUBJECT'			=> $crunch_data['crunch_subject'],
							'CRUNCH_MESSAGE'			=> $crunch_data['crunch_text'],
							'S_ERROR'					=> (sizeof($errors)) ? true : false,
							'ERROR_MSG'					=> implode('<br />', $errors),
							'CRUNCH_ACTION'				=> $this->u_action . '&amp;action=' . $action,
							'U_FIND_USERNAME'			=> append_sid("{$phpbb_root_path}memberlist.$phpEx", 'mode=searchuser&amp;form=crunch_manage&amp;field=username&amp;select_single=true'),
						));
						// Set title and title_explain stuff.
						$l_title = $user->lang['ACP_CRUNCH_MANAGE_TITLE'];
						$l_title_explain = $user->lang['ACP_CRUNCH_MANAGE_EXPLAIN'];
					break;
					
					case 'delete':
						// @NOTE: It's not too big a deal if we delete a Crunch, so we'll make it niiice and easy.
						// Check to see if the Crunch exists.
						if(!crunch::exists($crunch_id))
						{
							trigger_error($user->lang['INVALID_CRUNCH'] . adm_back_link($this->u_action), E_USER_WARNING);
						}
						else
						{
							$result = crunch::delete($crunch_id);
							if($result == true)
							{
								trigger_error($user->lang['CRUNCH_DELETED'] . adm_back_link($this->u_action));
							}
							else
							{
								trigger_error($user->lang['CRUNCH_DELETE_FAILED'] . adm_back_link($this->u_action), E_USER_WARNING);
							}
						}
					break;
					
					case 'browse':
					default:
						// Here we're going to browse the list of current Crunch entries. Because they don't have anything better to do.
						// Let's pull a list of Crunches to select...if there are any...
						$crunch_dropdown = false;
						$crunch_list = crunch::load_list();
						if($crunch_list !== false)
						{
							foreach($crunch_list as $crunch_list_data)
							{
								$url = $this->u_action . "&amp;crunch_id={$crunch_list_data['crunch_id']}";
								$template->assign_block_vars('crunches', array(
									'U_EDIT'			=> $url . '&amp;action=edit',
									'U_DELETE'			=> $url . '&amp;action=delete',
									'CRUNCH_SUBJECT'	=> censor_text($crunch_list_data['crunch_subject']),
								));
								//$crunch_dropdown .= '<option value="' . $crunch_list_data['crunch_id'] . '">' . censor_text($crunch_list_data['crunch_subject']) . '</option>';
							}
						}
						else
						{
							$template->assign_var('NO_CRUNCHES', true);
						}
						$template->assign_vars(array(
							'CRUNCH_EDIT_ACTION'	=> $this->u_action . '&amp;action=edit',
							'CRUNCH_ADD_ACTION'		=> $this->u_action . '&amp;action=add',
							'S_MODE_CRUNCH_BROWSE'	=> true,
						));
						// Set title and title_explain stuff.
						$l_title = $user->lang['ACP_CRUNCH_BROWSE_TITLE'];
						$l_title_explain = $user->lang['ACP_CRUNCH_BROWSE_EXPLAIN'];
					break;
				}
			break; //~ End module mode ACP_CRUNCH_MANAGE
			
			//~ Begin module mode ACP_CRUNCH_TAGS
			case 'tags':
				// Let's grab a few common variables in the ACP_CRUNCH_TAGS module mode first,
				// and then get around to figuring out what to do based on the action.
				
				$crunch_tag_id = request_var('crunch_tag_id', 0);
				$crunch_tag_word = request_var('crunch_tag_word', '');
			
				switch ($action)
				{
					case 'add':
						// Okay, I guess we're adding a Crunch Tag.
						
						// Let's start pulling some data about what we want.
						$crunch_tag_data = array(
							'crunch_id'		=> $crunch_id,
							'tag_word'		=> $crunch_tag_word,
							'tag_enable'	=> request_var('crunch_tag_enable', false),
						);
							
						// Did we submit the form?  Did it fail?
						if($submit && check_form_key($form_key) && !sizeof($errors))
						{
							// Is the Crunch specified valid?  (I hope so, a dropdown list should have been used to specify.)
							if(!crunch::exists($crunch_id))
							{
								$errors[] = $user->lang['INVALID_CRUNCH'];
							}
							
							// Is the Crunch Tag of the clean and proper format?
							if(!crunch::check_tag_format($crunch_tag_data['tag_word']))
							{
								$errors[] = $user->lang['INVALID_CRUNCH_TAG_WORD'];
							}
							
							// Make sure it's okay to submit, then...go!
							if(!sizeof($errors))
							{
								$result = crunch::make_tag($crunch_tag_data['crunch_id'], $crunch_tag_data['tag_word'], $crunch_tag_data['tag_enable']);
								if($result == false)
								{
									trigger_error($user->lang['CRUNCH_TAG_CREATE_FAILED'] . adm_back_link($this->u_action), E_USER_WARNING);
								}
								else
								{
									trigger_error($user->lang['CRUNCH_TAG_CREATED'] . adm_back_link($this->u_action));
								}
							}
						}
						
						// Here we're going to browse the list of current Crunch entries. Because they don't have anything better to do.
						// Let's pull a list of Crunches to select...if there are any...
						$crunch_dropdown = false;
						$crunch_list = crunch::load_list();
						if(!$crunch_list === false)
						{
							$crunch_dropdown = '';
							foreach($crunch_list as $crunch_list_data)
							{
								$crunch_dropdown .= '<option value="' . $crunch_list_data['crunch_id'] . '">' . censor_text($crunch_list_data['crunch_subject']) . '</option>';
							}
						}
						
						$template->assign_vars(array(
							'S_MODE_CRUNCH_TAGS_ADD'	=> true,
							'CRUNCH_LIST'			=> $crunch_dropdown,
							'CRUNCH_TAG_WORD'		=> $crunch_tag_data['tag_word'],
							'CRUNCH_TAG_ENABLE'		=> ($crunch_tag_data['tag_enable']) ? true : false,
						));
						// Set title and title_explain stuff.
						$l_title = $user->lang['ACP_CRUNCH_TAGS_ADD_TITLE'];
						$l_title_explain = $user->lang['ACP_CRUNCH_TAGS_ADD_EXPLAIN'];
					break;
					
					case 'delete':
						// @NOTE: It's not too big a deal if we delete a Crunch Tag, so we'll make it niiice and easy.
						// Check to see if the Crunch Tag exists.
						if(!crunch::tag_exists($crunch_id, $crunch_tag_word))
						{
							trigger_error($user->lang['INVALID_CRUNCH_TAG'] . adm_back_link($this->u_action), E_USER_WARNING);
						}
						else
						{
							$result = crunch::delete_tag($crunch_id, $crunch_tag_word);
							if($result == true)
							{
								trigger_error($user->lang['CRUNCH_TAG_DELETED'] . adm_back_link($this->u_action));
							}
							else
							{
								trigger_error($user->lang['CRUNCH_TAG_DELETE_FAILED'] . adm_back_link($this->u_action), E_USER_WARNING);
							}
						}
					break;
					
					case 'enable':
						// So, let's enable a Crunch Tag.
						// Check to see if the Crunch Tag exists.
						if(!crunch::tag_exists($crunch_id, $crunch_tag_word))
						{
							trigger_error($user->lang['INVALID_CRUNCH_TAG'] . adm_back_link($this->u_action), E_USER_WARNING);
						}
						else
						{
							$result = crunch::tag_enable($crunch_id, $crunch_tag_word, true);
							if($result == true)
							{
								trigger_error($user->lang['CRUNCH_TAG_ENABLED'] . adm_back_link($this->u_action));
							}
							else
							{
								trigger_error($user->lang['CRUNCH_TAG_ENABLE_FAILED'] . adm_back_link($this->u_action), E_USER_WARNING);
							}
						}
					break;
					
					case 'disable':
						// Quickly, we must make this Crunch Tag DISAPPEAR!
						// Check to see if the Crunch Tag exists.
						if(!crunch::tag_exists($crunch_id, $crunch_tag_word))
						{
							trigger_error($user->lang['INVALID_CRUNCH_TAG'] . adm_back_link($this->u_action), E_USER_WARNING);
						}
						else
						{
							$result = crunch::tag_enable($crunch_id, $crunch_tag_word, false);
							if($result == true)
							{
								trigger_error($user->lang['CRUNCH_TAG_DISABLED'] . adm_back_link($this->u_action));
							}
							else
							{
								trigger_error($user->lang['CRUNCH_TAG_DISABLE_FAILED'] . adm_back_link($this->u_action), E_USER_WARNING);
							}
						}
					break;
					
					case '':
						//Okay, so we're browsing.  Let's see what we've got for Crunch Tags to choose from.
						$crunch_tag_list = crunch::load_tag_list();
						if($crunch_tag_list === false)
						{
							$template->assign_var('NO_CRUNCH_TAGS', true);
						}
						else
						{
							foreach($crunch_tag_list as $crunch_tag_data)
							{
								$url = $this->u_action . "&amp;crunch_id={$crunch_tag_data['crunch_id']}&amp;crunch_tag_word={$crunch_tag_data['tag_word']}";
								$template->assign_block_vars('crunchtags', array(
									'CRUNCH_TAG_SUBJECT'	=> $crunch_tag_data['crunch_subject'],
									'CRUNCH_TAG_WORD'		=> $crunch_tag_data['tag_word'],
									'S_IS_ENABLED'			=> ($crunch_tag_data['tag_enable']) ? true : false,
									'U_DELETE'				=> $url . '&amp;action=delete',
									'U_ENABLE'				=> $url . '&amp;action=enable',
									'U_DISABLE'				=> $url . '&amp;action=disable',
								));
							}
						}
						
						// Ah, the browse mode.  I guess we ought to pull all the Crunch tags, and display them with all their goodies.
						$template->assign_vars(array(
							'S_MODE_CRUNCH_TAGS_BROWSE'		=> true,
						));
						// Set title and title_explain stuff.
						$l_title = $user->lang['ACP_CRUNCH_TAGS_BROWSE_TITLE'];
						$l_title_explain = $user->lang['ACP_CRUNCH_TAGS_BROWSE_EXPLAIN'];
					break;
				}
				
				//! Okay, I guess it's time to display stuffs.
				$template->assign_vars(array(
					'S_ERROR'						=> (sizeof($errors)) ? true : false,
					'ERROR_MSG'						=> implode('<br />', $errors),
					'CRUNCH_TAG_ADD_ACTION'			=> $this->u_action . '&amp;action=add',
					'ICON_ENABLE'					=> '<img src="' . $phpbb_admin_path . 'images/icon_sync.gif" alt="' . $user->lang['ENABLE'] . '" title="' . $user->lang['ENABLE'] . '" />',
					'ICON_DISABLE'					=> '<img src="' . $phpbb_admin_path . 'images/icon_sync.gif" alt="' . $user->lang['DISABLE'] . '" title="' . $user->lang['DISABLE'] . '" />',
				));
			break; //~ End module mode ACP_CRUNCH_TAGS
		}
		
		// Assign l_title and l_explain stuffs now.
		$this->page_title = $l_title;
		$template->assign_vars(array(
			'L_TITLE'			=> $l_title,
			'L_EXPLAIN'			=> $l_title_explain,
		));
	} // END acp_crunch::main() method
	
	/**
	 * Message preview
	 *
	 * Parse text and output proper template variables
	 * Assumes S_PREVIEW and CRUNCH_PREVIEW template variables
	 * Saves a few lines of code ;)
	 *
	 * Borrowed from phpBB Blog MOD
	 */
	function message_preview($message, $bbcode, $urls, $smilies)
	{
		global $template;

		$uid = $bitfield = $options = ''; // will be modified by generate_text_for_storage

		generate_text_for_storage($message, $uid, $bitfield, $options, $bbcode, $urls, $smilies);

		$template->assign_vars(array(
			'CRUNCH_PREVIEW'		=> generate_text_for_display($message, $uid, $bitfield, $options))
		);

		return true;
	}

}

?>