<?php
/**
*
*===================================================================
*
*  Crunch -- DCI File
*-------------------------------------------------------------------
*	Script info:
* Version:		1.0.0 - "Moonshine" - RC 2
* Copyright:	(c) 2009 - Obsidian
* License:		http://opensource.org/licenses/gpl-license.php  |  GNU Public License v2
* Package:		Install
*
*===================================================================
*
*/

/**
* Version info -
* @ignore
*/
	define('CRUNCH_VERSION', '1.0.0RC2');


/**
* @ignore
*/
	define('IN_PHPBB', true);
	$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : '../';
	$phpEx = substr(strrchr(__FILE__, '.'), 1);
	include($phpbb_root_path . 'common.' . $phpEx);

/**
* Start session management
*/
	$user->session_begin();
	$auth->acl($user->data);
	$user->setup(array('mods/lang_crunch', 'mods/lang_crunch_install'));
	// Define DB tables
	define('CRUNCH_TABLE', $table_prefix . 'crunch');
	define('CRUNCH_TAGS_TABLE', $table_prefix . 'crunch_tags');

//! Don't you know who /I/ am?
	if(!$user->data['is_registered'])
	{
		if($user->data['is_bot'])
		{
			redirect(append_sid("{$phpbb_root_path}index.$phpEx"));
		}
		// Hold on, my ID has /got/ to be in here somewhere..
		login_box('', 'LOGIN');
	}
	elseif((int) $user->data['user_type'] !== USER_FOUNDER)
	{
		//! Give them das boot out of there.  :3
		trigger_error('NOT_AUTHORIZED');
	}

//! Mode check...where shall we go tomorrow?
	$mode = request_var('mode', '');

	switch($mode)
	{
		case 'install':
			if (isset($config['crunch_version']))
			{
				trigger_error('CRUNCH_INSTALL_FAILED_NO_REINST');
			}
			//Implicit else.
			
			$install_path = './schemas/';
		//! Load in the schema and execute.  This may get bloody.  @_@;;
			load_schema($install_path, false);

		//! Setup $auth_admin class to add...a turkey sandwich?  Nah, just more auths.  :P
			include_once($phpbb_root_path . 'includes/acp/auth.' . $phpEx);
			$auth_admin = new auth_admin();
			$auth_admin->acl_add_option(array(
				'local'		=> array(),
				'global'	=> array('a_crunch_settings', 'a_crunch_manage', 'a_crunch_tags'),
			));
		//! Configuratization-mabobber-jigger-whatsit.  :D
			set_config('crunch_enabled', 0); //Defaults to disabled so initial Crunches can be added before the system is used.
			set_config('crunch_version', CRUNCH_VERSION);
			
			/**
			* EAMI integration for lazy people.  XD
			*/
			include($phpbb_root_path . 'install_crunch/eami.' . $phpEx);
			$eami = new eami();

			// Add our ACP module and a parent module...
			// Parent module...
			$module_data = array(
				'module_langname'	=> 'ACP_CRUNCH_PARENT',
			);
			$eami->add_module('acp', 'ACP_CAT_DOT_MODS', $module_data);		
			
			// Main modules...
			$sql_ary = array(
				'module_basename'	=> 'crunch',
				'module_langname'	=> 'ACP_CRUNCH_SETTINGS',
				'module_mode'		=> 'settings',
				'module_auth'		=> 'acl_a_crunch_settings');
			$eami->add_module('acp', 'ACP_CRUNCH_PARENT', $sql_ary);
			$sql_ary = array(
				'module_basename'	=> 'crunch',
				'module_langname'	=> 'ACP_CRUNCH_MANAGE',
				'module_mode'		=> 'manage',
				'module_auth'		=> 'acl_a_crunch_manage');
			$eami->add_module('acp', 'ACP_CRUNCH_PARENT', $sql_ary);
			$sql_ary = array(
				'module_basename'	=> 'crunch',
				'module_langname'	=> 'ACP_CRUNCH_TAGS',
				'module_mode'		=> 'tags',
				'module_auth'		=> 'acl_a_crunch_tags');
			$eami->add_module('acp', 'ACP_CRUNCH_PARENT', $sql_ary);
			
			trigger_error('CRUNCH_INSTALLED');
		break;


		case 'upgrade':
			if(!isset($config['crunch_version']))
			{
				trigger_error('CRUNCH_UPGRADE_FAILED_NOT_INST');
			}
			if(!version_compare($config['crunch_version'], CRUNCH_VERSION, '<'))
			{
				trigger_error('CRUNCH_INSTALL_UP_TO_DATE');
			}
			//Implicit else of previous checks.
		//! Upgrade cycle...only ever use /two/ breaks. One at the end of the upgrade cycle, the other for version recognition failure.  
			switch ($config['crunch_version'])
			{
				case '1.0.0 A 1':
					//Nil.
				case '1.0.0 B 1':
					//Nothing.
				case '1.0.0 B 2':
					//ZOMG, nothing.
				case '1.0.0 B 3':
					//ZOMGBBQ, NOTHING!
				case '1.0.0RC1':
					//Nada.
				
					//And set version..
					set_config('crunch_version', CRUNCH_VERSION);
				break;
				default:
					trigger_error('CRUNCH_UPGRADE_FAILED_UNK_VERS');
				break;
			}
			trigger_error('CRUNCH_UPGRADED');
		break;


		default:
			//Check the version config entry and see what we should do.
			if(isset($config['crunch_version']))
			{
				if(version_compare($config['crunch_version'], CRUNCH_VERSION, '<'))
				{
					trigger_error($user->lang['CRUNCH_UPGRADE_MAIN'] . '<br /><br />' .  '<a href="' . append_sid("{$phpbb_root_path}install_crunch/index.$phpEx", 'mode=upgrade') . '">' . $user->lang['UPGRADE_CRUNCH'] . '</a>');
				}
				else
				{
					trigger_error('CRUNCH_INSTALL_UP_TO_DATE');
				}
			}
			else
			{
				trigger_error($user->lang['CRUNCH_INSTALL_MAIN'] . '<br /><br />' .  '<a href="' . append_sid("{$phpbb_root_path}install_crunch/index.$phpEx", 'mode=install') . '">' . $user->lang['INSTALL_CRUNCH'] . '</a>');
			}
		break;
	}

/**
* Load a schema (and execute)
*
* @param string $install_path Path to folder containing schema files
* @param mixed $install_dbms Alternative database system than $dbms
*/
function load_schema($install_path = '', $install_dbms = false)
{
	global $db;
	global $table_prefix;

	if ($install_dbms === false)
	{
		global $dbms;
		$install_dbms = $dbms;
	}

	static $available_dbms = false;

	if (!$available_dbms)
	{
		if (!function_exists('get_available_dbms'))
		{
			global $phpbb_root_path, $phpEx;
			include($phpbb_root_path . 'includes/functions_install.' . $phpEx);
		}

		$available_dbms = get_available_dbms($install_dbms);

		if ($install_dbms == 'mysql')
		{
			if (version_compare($db->sql_server_info(true), '4.1.3', '>='))
			{
				$available_dbms[$install_dbms]['SCHEMA'] .= '_41';
			}
			else
			{
				$available_dbms[$install_dbms]['SCHEMA'] .= '_40';
			}
		}
	}

	$remove_remarks = $available_dbms[$install_dbms]['COMMENTS'];
	$delimiter = $available_dbms[$install_dbms]['DELIM'];

	$dbms_schema = $install_path . $available_dbms[$install_dbms]['SCHEMA'] . '_schema.sql';

	if (file_exists($dbms_schema))
	{
		$sql_query = @file_get_contents($dbms_schema);
		$sql_query = preg_replace('#phpbb_#i', $table_prefix, $sql_query);

		$remove_remarks($sql_query);

		$sql_query = split_sql_file($sql_query, $delimiter);

		foreach ($sql_query as $sql)
		{
			$db->sql_query($sql);
		}
		unset($sql_query);
	}

	if (file_exists($install_path . 'schema_data.sql'))
	{
		$sql_query = file_get_contents($install_path . 'schema_data.sql');

		switch ($install_dbms)
		{
			case 'mssql':
			case 'mssql_odbc':
				$sql_query = preg_replace('#\# MSSQL IDENTITY (phpbb_[a-z_]+) (ON|OFF) \##s', 'SET IDENTITY_INSERT \1 \2;', $sql_query);
			break;

			case 'postgres':
				$sql_query = preg_replace('#\# POSTGRES (BEGIN|COMMIT) \##s', '\1; ', $sql_query);
			break;
		}

		$sql_query = preg_replace('#phpbb_#i', $table_prefix, $sql_query);
		$sql_query = preg_replace_callback('#\{L_([A-Z0-9\-_]*)\}#s', 'adjust_language_keys_callback', $sql_query);

		remove_remarks($sql_query);

		$sql_query = split_sql_file($sql_query, ';');

		foreach ($sql_query as $sql)
		{
			$db->sql_query($sql);
		}
		unset($sql_query);
	}
}


?>
