#
# $Id: $
#


# Table: 'phpbb_crunch'
CREATE TABLE phpbb_crunch (
	crunch_id INTEGER NOT NULL,
	poster_id INTEGER DEFAULT 0 NOT NULL,
	crunch_subject VARCHAR(255) CHARACTER SET UTF8 DEFAULT '' NOT NULL COLLATE UNICODE,
	crunch_text BLOB SUB_TYPE TEXT CHARACTER SET UTF8 DEFAULT '' NOT NULL,
	crunch_options INTEGER DEFAULT 7 NOT NULL,
	crunch_bitfield VARCHAR(255) CHARACTER SET NONE DEFAULT '' NOT NULL,
	crunch_uid VARCHAR(8) CHARACTER SET NONE DEFAULT '' NOT NULL
);;

ALTER TABLE phpbb_crunch ADD PRIMARY KEY (crunch_id);;


CREATE GENERATOR phpbb_crunch_gen;;
SET GENERATOR phpbb_crunch_gen TO 0;;

CREATE TRIGGER t_phpbb_crunch FOR phpbb_crunch
BEFORE INSERT
AS
BEGIN
	NEW.crunch_id = GEN_ID(phpbb_crunch_gen, 1);
END;;


# Table: 'phpbb_crunch_tags'
CREATE TABLE phpbb_crunch_tags (
	tag_id INTEGER NOT NULL,
	crunch_id INTEGER DEFAULT 0 NOT NULL,
	tag_word VARCHAR(255) CHARACTER SET UTF8 DEFAULT '' NOT NULL COLLATE UNICODE,
	tag_enable INTEGER DEFAULT 1 NOT NULL
);;

ALTER TABLE phpbb_crunch_tags ADD PRIMARY KEY (tag_id);;


CREATE GENERATOR phpbb_crunch_tags_gen;;
SET GENERATOR phpbb_crunch_tags_gen TO 0;;

CREATE TRIGGER t_phpbb_crunch_tags FOR phpbb_crunch_tags
BEFORE INSERT
AS
BEGIN
	NEW.tag_id = GEN_ID(phpbb_crunch_tags_gen, 1);
END;;


