/*

 $Id: $

*/

/*
  This first section is optional, however its probably the best method
  of running phpBB on Oracle. If you already have a tablespace and user created
  for phpBB you can leave this section commented out!

  The first set of statements create a phpBB tablespace and a phpBB user,
  make sure you change the password of the phpBB user before you run this script!!
*/

/*
CREATE TABLESPACE "PHPBB"
	LOGGING
	DATAFILE 'E:\ORACLE\ORADATA\LOCAL\PHPBB.ora'
	SIZE 10M
	AUTOEXTEND ON NEXT 10M
	MAXSIZE 100M;

CREATE USER "PHPBB"
	PROFILE "DEFAULT"
	IDENTIFIED BY "phpbb_password"
	DEFAULT TABLESPACE "PHPBB"
	QUOTA UNLIMITED ON "PHPBB"
	ACCOUNT UNLOCK;

GRANT ANALYZE ANY TO "PHPBB";
GRANT CREATE SEQUENCE TO "PHPBB";
GRANT CREATE SESSION TO "PHPBB";
GRANT CREATE TABLE TO "PHPBB";
GRANT CREATE TRIGGER TO "PHPBB";
GRANT CREATE VIEW TO "PHPBB";
GRANT "CONNECT" TO "PHPBB";

COMMIT;
DISCONNECT;

CONNECT phpbb/phpbb_password;
*/
/*
	Table: 'phpbb_crunch'
*/
CREATE TABLE phpbb_crunch (
	crunch_id number(8) NOT NULL,
	poster_id number(8) DEFAULT '0' NOT NULL,
	crunch_subject varchar2(765) DEFAULT '' ,
	crunch_text clob DEFAULT '' ,
	crunch_options number(11) DEFAULT '7' NOT NULL,
	crunch_bitfield varchar2(255) DEFAULT '' ,
	crunch_uid varchar2(8) DEFAULT '' ,
	CONSTRAINT pk_phpbb_crunch PRIMARY KEY (crunch_id)
)
/


CREATE SEQUENCE phpbb_crunch_seq
/

CREATE OR REPLACE TRIGGER t_phpbb_crunch
BEFORE INSERT ON phpbb_crunch
FOR EACH ROW WHEN (
	new.crunch_id IS NULL OR new.crunch_id = 0
)
BEGIN
	SELECT phpbb_crunch_seq.nextval
	INTO :new.crunch_id
	FROM dual;
END;
/


/*
	Table: 'phpbb_crunch_tags'
*/
CREATE TABLE phpbb_crunch_tags (
	tag_id number(8) NOT NULL,
	crunch_id number(8) DEFAULT '0' NOT NULL,
	tag_word varchar2(765) DEFAULT '' ,
	tag_enable number(1) DEFAULT '1' NOT NULL,
	CONSTRAINT pk_phpbb_crunch_tags PRIMARY KEY (tag_id)
)
/


CREATE SEQUENCE phpbb_crunch_tags_seq
/

CREATE OR REPLACE TRIGGER t_phpbb_crunch_tags
BEFORE INSERT ON phpbb_crunch_tags
FOR EACH ROW WHEN (
	new.tag_id IS NULL OR new.tag_id = 0
)
BEGIN
	SELECT phpbb_crunch_tags_seq.nextval
	INTO :new.tag_id
	FROM dual;
END;
/


