<?php
/**
*
*===================================================================
*
*  Crunch -- Documentation Language File
*-------------------------------------------------------------------
*	Script info:
* Version:		1.0.0 - "Moonshine" - RC 2
* Copyright:	(c) 2009 - Obsidian
* License:		http://opensource.org/licenses/gpl-license.php  |  GNU Public License v2
* Package:		Language [en]
*
*===================================================================
*
*/

/**
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

// DEVELOPERS PLEASE NOTE
//
// All language files should use UTF-8 as their encoding and the files must not contain a BOM.
//
// Placeholders can now contain order information, e.g. instead of
// 'Page %s of %s' you can (and should) write 'Page %1$s of %2$s', this allows
// translators to re-order the output of data while ensuring it remains correct
//
// You do not need this where single placeholders are used, e.g. 'Message %d' is fine
// equally where a string contains only two placeholders which are used to wrap text
// in a url you again do not need to specify an order e.g., 'Click %sHERE%s' is fine

$help = array(
	array(
		0 => '--',
		1 => 'Main Information'
	),
	array(
		0 => 'What is Crunch?',
		1 => 'Crunch\'s purpose is to create a set of user-definable posts within the ACP, 
			to remove reliance on hidden forums (like with the function get_fora_topics) to pull post information.'
	),
	array(
		0 => 'What could I use Crunch for?',
		1 => 'Just about anything.  It\'s great for use with error pages, info posts on a home page, a backend for building a download repository, etc.'
	),
	array(
		0 => 'Can I distribute it?',
		1 => 'Sure, you can distribute it, as per version 2.0 the GNU General Public License.'
	),
	array(
		0 => 'What do I need to run Crunch?',
		1 => 'You will need phpBB 3.0.5 or greater and PHP 5.1 or greater.'
	),
	array(
		0 => '--',
		1 => 'Use and Installation'
	),
	array(
		0 => 'How do I install it?',
		1 => 'Simply copy over the files to the proper locations, and then run the provided install script at {phpBB3 root}/install_crunch/index.php'
	),
	array(
		0 => 'How do I use it? (Frontend)',
		1 => 'In your frontend PHP files, simply add two lines.  <br /><dl class="codebox"><dt>Code:</dt><dd><code>include(&quot;{$phpbb_root_path}includes/crunch.$phpEx&quot;);<br />
				crunch::init();<br />crunch::load(&quot;crunch_tag_word_here&quot;); </code></dd></dl><br />
				This will automatically load a random Crunch that has the Crunch Tag you specified (where crunch_tag_word_here is your specified Crunch Tag).<br /><br />
				Also, you will need to add in the template file.  In the desired location, add in the line <br /><dl class="codebox"><dt>Code:</dt><dd><code>&lt;!-- INCLUDE crunch_body.html --&gt;</code></dd></dl>'
	),
	array(
		0 => '--',
		1 => 'Updating Crunch and checking for updates'
	),
	array(
		0 => 'How do I check for updates?',
		1 => 'In the ACP, go to the .MODS tab, and select the Modules &quot;Crunch Settings&quot;, then click the &quot;Run Now&quot; button in the Version Check section.
			Crunch will then automatically check for updates.  If the update check fails for some reason, 
			look at <a href="http://phpbbmodders.net/board/viewtopic.php?f=37&amp;t=3529">this page</a> and compare the released version number to the currently installed version number.'
	),
	array(
		0 => 'How do I update Crunch?',
		1 => 'Instructions will be provided with each update, but the standard procedure should be to upload all new files, then run the provided installation script.
			It should detect that there is a previous installation of Crunch and update the database component to the most recent version.'
	),
);

?>