<?php
/**
*
*===================================================================
*
*  Crunch -- Language File
*-------------------------------------------------------------------
*	Script info:
* Version:		1.0.0 - "Moonshine" - RC 2
* Copyright:	(c) 2009 - Obsidian
* License:		http://opensource.org/licenses/gpl-license.php  |  GNU Public License v2
* Package:		Language [en]
*
*===================================================================
*
*/

/**
* DO NOT CHANGE
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

if (empty($lang) || !is_array($lang))
{
	$lang = array();
}

// DEVELOPERS PLEASE NOTE
//
// All language files should use UTF-8 as their encoding and the files must not contain a BOM.
//
// Placeholders can now contain order information, e.g. instead of
// 'Page %s of %s' you can (and should) write 'Page %1$s of %2$s', this allows
// translators to re-order the output of data while ensuring it remains correct
//
// You do not need this where single placeholders are used, e.g. 'Message %d' is fine
// equally where a string contains only two placeholders which are used to wrap text
// in a url you again do not need to specify an order e.g., 'Click %sHERE%s' is fine

$lang = array_merge($lang, array(
	'LATEST'								=> 'Latest',
	'CRUNCH_DISABLED'						=> 'Crunch is disabled',
	
	'CRUNCH_NOT_INSTALLED'					=> 'Crunch must be installed before this ACP Module can be used.',
	'CRUNCH_DB_NOT_CURRENT'					=> 'The database component of Crunch is not current.  Please run the provided update script.',
	'CRUNCH_INSTALL_DIR_PRESENT'			=> 'Crunch cannot be used while its install directory is present.',

	'REMOTE_CRUNCH_VERSION'					=> 'Current Crunch Release',
	'CURRENT_CRUNCH_VERSION'				=> 'Installed Crunch Version',
	'CHECK_FOR_UPDATES'						=> 'Check for updates',
	'VERSION_CHECK'							=> 'Version Check',
	'CURRENT_VERSION'						=> 'Installed Version',
	'CRUNCH_IS_UP_TO_DATE'					=> 'Your Crunch installation is up to date.',
	'UPDATE_AVAILABLE'						=> 'Update available',
	'CRUNCH_GET_UPDATE'						=> 'Information on updating Crunch can be found at <a href="%1$s">this page</a>.<br /> If you are ready to begin the update process, <a href="%2$s">click here</a>.',

	'CRUNCH_ENABLED'						=> 'Enable Crunch',
	'CRUNCH_ENABLED_EXPLAIN'				=> 'Enable Crunch for board-wide use.',

	'CRUNCH_AUTHOR'							=> 'Crunch Author',
	'CRUNCH_AUTHOR_EXPLAIN'					=> 'Which user should appear as this Crunch\'s author?',
	'CRUNCH_SUBJECT'						=> 'Crunch',
	'CRUNCH_SUBJECT_CREATE'					=> 'Crunch Title',
	'CRUNCH_PREVIEW'						=> 'Crunch Message Preview',
	'CRUNCH_MESSAGE'						=> 'Crunch Contents',
	'CRUNCH_MESSAGE_EXPLAIN'				=> 'What should this Crunch say?',
	'CRUNCH_SELECT'							=> 'Select a Crunch',
	'CRUNCH_SELECT_THIS'					=> 'Select this Crunch',
	'CRUNCH_CREATE'							=> 'Create new Crunch',
	'CRUNCH_CREATE_TAG'						=> 'Create new Crunch Tag',
	'CRUNCH_TAG_WORD'						=> 'Crunch Tag Word',
	'CRUNCH_TAG_WORD_EXPLAIN'				=> 'A keyword that would be unique to this particular Crunch for identifying it for use with load_crunch().  (Only use alphanumeric characters, _ and -)',
	'CRUNCH_TAG_ENABLE'						=> 'Enable Crunch Tag',
	'CRUNCH_TAG_ENABLE_EXPLAIN'				=> 'Enable Crunch Tag on creation',
	'CRUNCH_IS_ENABLED'						=> 'Crunch Tag Enabled?',
	'CRUNCH_MANAGE'							=> 'Manage Crunches',
	'CRUNCH_TAG_MANAGE'						=> 'Manage Crunch Tags',
	'CRUNCH_TAG_ENABLED'					=> 'Crunch Tag enabled',
	'CRUNCH_TAG_DISABLED'					=> 'Crunch Tag disabled',
	'ACP_CRUNCH_SETTINGS_TITLE'				=> 'Crunch Settings',
	'ACP_CRUNCH_SETTINGS_EXPLAIN'			=> 'Here you can change some common Crunch settings and check for a new Crunch version.',
	'ACP_CRUNCH_MANAGE_TITLE'				=> 'Manage Crunches',
	'ACP_CRUNCH_MANAGE_EXPLAIN'				=> 'Here you can manage your current Crunches by adding, removing, or editing them to suit your needs.',
	'ACP_CRUNCH_BROWSE_TITLE'				=> 'Browse Crunches',
	'ACP_CRUNCH_BROWSE_EXPLAIN'				=> 'Here you can choose a Crunch to edit, or begin adding a new Crunch.',
	'ACP_CRUNCH_TAGS_ADD_TITLE'				=> 'Add Crunch Tag',
	'ACP_CRUNCH_TAGS_ADD_EXPLAIN'			=> 'Here you can add Crunch Tags to a specific Crunch in order to identify it later.',
	'ACP_CRUNCH_TAGS_BROWSE_TITLE'			=> 'Browse Crunch Tags',
	'ACP_CRUNCH_TAGS_BROWSE_EXPLAIN'		=> 'Here you can enable, disable, and add Crunch Tags.',

	'NO_CRUNCH_TAGS'					=> 'No Crunch Tags found',
	'NO_CRUNCHES'						=> 'No Crunches found',
	'INVALID_CRUNCH'					=> 'Invalid Crunch ID provided.',
	'INVALID_CRUNCH_TAG'				=> 'Invalid Crunch Tag ID provided.',
	'INVALID_CRUNCH_TAG_WORD'			=> 'Invalid Crunch Tag word provided.',
	'CRUNCH_POST_FAILED'				=> 'The creation of your Crunch was unsuccessful.',
	'CRUNCH_POST_SUCCESS'				=> 'The creation of your Crunch was successful.',
	'CRUNCH_EDIT_FAILED'				=> 'The Crunch edit was unsuccessful.',
	'CRUNCH_EDIT_SUCCESS'				=> 'The Crunch edit was successful.',
	'CRUNCH_DELETED'					=> 'The deletion of the Crunch was successful.',
	'CRUNCH_DELETE_FAILED'				=> 'The deletion of the Crunch was unsuccessful.',
	'CRUNCH_TAG_CREATED'				=> 'The creation of the Crunch Tag was successful.',
	'CRUNCH_TAG_CREATE_FAILED'			=> 'The creation of the Crunch Tag was unsuccessful.',
	'CRUNCH_TAG_DELETED'				=> 'The deletion of the Crunch Tag was successful.',
	'CRUNCH_TAG_DELETE_FAILED'			=> 'The deletion of the Crunch Tag was unsuccessful.',
	'CRUNCH_TAG_IS_ENABLED'				=> 'Enabled',
	'CRUNCH_TAG_IS_DISABLED'			=> 'Disabled',
	'CRUNCH_TAG_ENABLED'				=> 'The Crunch Tag was successfully enabled.',
	'CRUNCH_TAG_ENABLE_FAILED'			=> 'The Crunch Tag could not be enabled.',
	'CRUNCH_TAG_DISABLED'				=> 'The Crunch Tag was successfully disabled.',
	'CRUNCH_TAG_DISABLE_FAILED'			=> 'The Crunch Tag could not be disabled.',
	
	'CRUNCH_DOCS_EXPLAIN'				=> 'Crunch Documentation',
));
?>
